<?php
/*
	#	UfitPay Payment module callback for Sendroid Ultimate
	#	location: gateway/paywithufitpay/index.php
	#	Developed by: Ynet Interactive
	#	Special thanks: Mr. White
*/
define('ENVIRONMENT', 'production');
ob_start();
session_start();
$URL = 'dashboard';
if(isset($_GET['url']))
{ 
	$URL = $_GET['url'];
}

if (defined('ENVIRONMENT')){
	switch (ENVIRONMENT) {
		case 'development':
			error_reporting(E_ALL);
		break;
	
		case 'testing':
		case 'production':
			error_reporting(0);
		break;

		default:
			exit('The application environment is not set correctly.');
	}
}
$system_path = '../../system';
$application_folder = 'hooks';
$module_folder = 'modules';
	// Set the current directory correctly for CLI requests
	if (defined('STDIN'))
	{
		chdir(dirname(__FILE__));
	}

	if (realpath($system_path) !== FALSE)
	{
		$system_path = realpath($system_path).'/';
	}

	// ensure there's a trailing slash
	$system_path = rtrim($system_path, '/').'/';
	// Is the system path correct?
	if ( ! is_dir($system_path))
	{
		exit("Your system folder path does not appear to be set correctly. Please open the following file and correct this: ".pathinfo(__FILE__, PATHINFO_BASENAME));
	}
	// The name of THIS file
	define('SELF', pathinfo(__FILE__, PATHINFO_BASENAME));
	// The PHP file extension
	// this global constant is deprecated.
	define('EXT', '.php');
	// Path to the system folder
	define('BASEPATH', str_replace("\\", "/", $system_path));
	// Path to the front controller (this file)
	define('FCPATH', str_replace(SELF, '', __FILE__));
	// Name of the "system folder"
	define('SYSDIR', trim(strrchr(trim(BASEPATH, '/'), '/'), '/'));

	// The path to the "application" folder
	if (is_dir($application_folder))
	{
		define('APPPATH', $application_folder.'/');
		define('MODPATH', $module_folder.'/');
	}
	else
	{
		if ( ! is_dir(BASEPATH.$application_folder.'/'))
		{
			exit("Your application folder path does not appear to be set correctly. Please open the following file and correct this: ".SELF);
		}

		define('APPPATH', BASEPATH.$application_folder.'/');
		define('MODPATH', BASEPATH.$module_folder.'/');
	}
define('COR', BASEPATH.'core/');	
define('LIB', BASEPATH.'libraries/');	
define('HELP', BASEPATH.'helpers/');	
require_once '../../root.php';
require_once BASEPATH.'core/Config.php';
foreach (glob(COR."/*.php") as $filename) { include $filename; }
foreach (glob(HELP."/*.php") as $filename) { include $filename; }
foreach (glob(LIB."/*.php") as $filename) { include $filename; }
$Config = new CI_Config();
setTimeZone();
require_once BASEPATH.'lang/'.setLang(1);
global $server;

if(isset($_REQUEST['transaction_reference']) && isset($_REQUEST['service_code']) && isset($_REQUEST['tnx_ref'])) {
	$tnx_ref = mysqli_real_escape_string($server,$_REQUEST['tnx_ref']);
	$query2="SELECT * FROM transactions WHERE reference = '$tnx_ref' LIMIT 1"; 
	$result2 = mysqli_query($server,$query2);  
	$usesSess2 = mysqli_num_rows($result2);
	if($usesSess2 < 1) {
		die("Invalid transaction ref");
	} else {
		$row = mysqli_fetch_assoc($result2); 
		$expected_amount = $row['amount'];
		$user_id = $row['customer_id'];
		$Payment_gateway = $row['method'];
	}
	$currency = paymentGatewayData($Payment_gateway,'currency_id');			
	$user_currency = userData($user_id,'currency_id');				
	$currency_code = currencyCode($user_currency);					
	$amount_converted = $expected_amount*currencyRate($currency);		
	if($currency_code==$currency) {
		$amount_converted = $expected_amount;			
	}
						
	$merchant_key = trim(paymentGatewayData($Payment_gateway,'param1'));		
	$merchant_token = trim(paymentGatewayData($Payment_gateway,'param2'));	
		
	$service_code = mysqli_real_escape_string($server,$_REQUEST['service_code']);
	$customer_account_id = mysqli_real_escape_string($server,$_REQUEST['customer_account_id']);
	$customer_email = mysqli_real_escape_string($server,$_REQUEST['customer_email']);
	$transaction_date = mysqli_real_escape_string($server,$_REQUEST['transaction_date']);
	$transaction_reference = mysqli_real_escape_string($server,$_REQUEST['transaction_reference']);
	$amount = mysqli_real_escape_string($server,$_REQUEST['transaction_value']);
	$description = mysqli_real_escape_string($server,$_REQUEST['description']);
	$session_id = mysqli_real_escape_string($server,$_REQUEST['session_id']);
	if(!empty($transaction_reference)) {
	    //validate
	    $ch = curl_init();
		curl_setopt($ch,CURLOPT_URL,"https://api.ufitpay.com/v1/verify_payment");
		curl_setopt($ch,CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS,   http_build_query(array('transaction_reference' => $transaction_reference)));
		curl_setopt($ch,CURLOPT_RETURNTRANSFER, true);
		curl_setopt($ch,CURLOPT_SSL_VERIFYPEER, false);
		$headers = array (
			'Api-Token: '.$merchant_token,
			'Api-Key: '.$merchant_key,
			'content-type: application/x-www-form-urlencoded'
		);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		$server_output = curl_exec ($ch);
		curl_close($ch);
		
		$data = json_decode($server_output,true);
		if($data['status'] =="success") {
		    $datas = $data['data'];
		    $payment_status = $datas['status'];
		    $payment_amount = $datas['transaction_value']; 
		    $payment_service = $datas['service_code'];
		    $payment_customer = $datas['customer_account_id'];
		    $credit_account_number = $datas['credit_account_number'];
		    $online_reference = $datas['session_id'];
		    $request_ref = $datas['request_ref'];

		    if($payment_status=="completed" && $payment_amount > 0 && $usesSess < 1) {
		        //check payment type
		        if($payment_service == "bank_deposit") {
            		    if($payment_amount >= $amount_converted) {
								processTransaction($tnx_ref);
            		    }
            		    die('300'); 
		        }
		    } else {
		         die('Payment not completed'); 
		    }
		} else {
		     die('Transaction not verified'); 
		}
	} else {
	     die('Payment not vcerified'); 
	}	
}
?>
